package com.sun.org.apache.xml.internal.security.utils;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.BufferedReader;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import com.sun.org.apache.xml.internal.security.exceptions.Base64DecodingException;
import org.w3c.dom.Element;
import java.math.BigInteger;

@Deprecated
public class Base64
{
    public static final int BASE64DEFAULTLENGTH = 76;
    private static final int BASELENGTH = 255;
    private static final int LOOKUPLENGTH = 64;
    private static final int TWENTYFOURBITGROUP = 24;
    private static final int EIGHTBIT = 8;
    private static final int SIXTEENBIT = 16;
    private static final int FOURBYTE = 4;
    private static final int SIGN = -128;
    private static final char PAD = '=';
    private static final byte[] base64Alphabet;
    private static final char[] lookUpBase64Alphabet;
    
    private Base64() {
    }
    
    static final byte[] getBytes(BigInteger bigInteger, int n) {
        n = n + 7 >> 3 << 3;
        if (n < bigInteger.bitLength()) {
            throw new IllegalArgumentException(I18n.translate("utils.Base64.IllegalBitlength"));
        }
        byte[] byteArray = bigInteger.toByteArray();
        if (bigInteger.bitLength() % 8 != 0 && bigInteger.bitLength() / 8 + 1 == n / 8) {
            return byteArray;
        }
        int n2 = 0;
        int length = byteArray.length;
        if (bigInteger.bitLength() % 8 == 0) {
            n2 = 1;
            --length;
        }
        int n3 = n / 8 - length;
        byte[] array = new byte[n / 8];
        System.arraycopy(byteArray, n2, array, n3, length);
        return array;
    }
    
    public static final String encode(BigInteger bigInteger) {
        return XMLUtils.encodeToString(XMLUtils.getBytes(bigInteger, bigInteger.bitLength()));
    }
    
    public static final byte[] encode(BigInteger bigInteger, int n) {
        n = n + 7 >> 3 << 3;
        if (n < bigInteger.bitLength()) {
            throw new IllegalArgumentException(I18n.translate("utils.Base64.IllegalBitlength"));
        }
        byte[] byteArray = bigInteger.toByteArray();
        if (bigInteger.bitLength() % 8 != 0 && bigInteger.bitLength() / 8 + 1 == n / 8) {
            return byteArray;
        }
        int n2 = 0;
        int length = byteArray.length;
        if (bigInteger.bitLength() % 8 == 0) {
            n2 = 1;
            --length;
        }
        int n3 = n / 8 - length;
        byte[] array = new byte[n / 8];
        System.arraycopy(byteArray, n2, array, n3, length);
        return array;
    }
    
    public static final BigInteger decodeBigIntegerFromElement(Element element) throws Base64DecodingException {
        return new BigInteger(1, decode(element));
    }
    
    public static final BigInteger decodeBigIntegerFromText(Text text) throws Base64DecodingException {
        return new BigInteger(1, decode(text.getData()));
    }
    
    public static final void fillElementWithBigInteger(Element element, BigInteger bigInteger) {
        String str = encode(bigInteger);
        if (!XMLUtils.ignoreLineBreaks() && str.length() > 76) {
            str = "\n" + str + "\n";
        }
        element.appendChild(element.getOwnerDocument().createTextNode(str));
    }
    
    public static final byte[] decode(Element element) throws Base64DecodingException {
        Node node = element.getFirstChild();
        StringBuilder sb = new StringBuilder();
        while (node != null) {
            if (node.getNodeType() == 3) {
                sb.append(((Text)node).getData());
            }
            node = node.getNextSibling();
        }
        return decode(sb.toString());
    }
    
    public static final Element encodeToElement(Document document, String s, byte[] array) {
        Element elementInSignatureSpace = XMLUtils.createElementInSignatureSpace(document, s);
        elementInSignatureSpace.appendChild(document.createTextNode(encode(array)));
        return elementInSignatureSpace;
    }
    
    public static final byte[] decode(byte[] array) throws Base64DecodingException {
        return decodeInternal(array, -1);
    }
    
    public static final String encode(byte[] array) {
        return XMLUtils.ignoreLineBreaks() ? encode(array, Integer.MAX_VALUE) : encode(array, 76);
    }
    
    public static final byte[] decode(BufferedReader bufferedReader) throws IOException, Base64DecodingException {
        byte[] byteArray = null;
        UnsyncByteArrayOutputStream unsyncByteArrayOutputStream = new UnsyncByteArrayOutputStream();
        try {
            String line;
            while (null != (line = bufferedReader.readLine())) {
                unsyncByteArrayOutputStream.write(decode(line));
            }
            byteArray = unsyncByteArrayOutputStream.toByteArray();
        }
        finally {
            unsyncByteArrayOutputStream.close();
        }
        return byteArray;
    }
    
    protected static final boolean isWhiteSpace(byte b) {
        return b == 32 || b == 13 || b == 10 || b == 9;
    }
    
    protected static final boolean isPad(byte b) {
        return b == 61;
    }
    
    public static final String encode(byte[] array, int n) {
        if (n < 4) {
            n = Integer.MAX_VALUE;
        }
        if (array == null) {
            return null;
        }
        long n2 = (long)array.length * 8L;
        if (n2 == 0L) {
            return "";
        }
        long n3 = n2 % 24L;
        int n4 = (int)(n2 / 24L);
        n4 = ((n3 != 0L) ? (n4 + 1) : n4);
        int n5 = (n4 - 1) / (n / 4);
        char[] value = new char[n4 * 4 + n5 * 2];
        int n6 = 0;
        int n7 = 0;
        int i = 0;
        for (int j = 0; j < n5; value[n6++] = '\r', value[n6++] = '\n', ++j) {
            for (int k = 0; k < 19; ++k) {
                int n8 = array[n7++];
                int n9 = array[n7++];
                int n10 = array[n7++];
                int n11 = (byte)(n9 & 0xF);
                int n12 = (byte)(n8 & 0x3);
                int n13 = ((n8 & 0xFFFFFF80) == 0x0) ? ((byte)(n8 >> 2)) : ((byte)(n8 >> 2 ^ 0xC0));
                int n14 = ((n9 & 0xFFFFFF80) == 0x0) ? ((byte)(n9 >> 4)) : ((byte)(n9 >> 4 ^ 0xF0));
                int n15 = ((n10 & 0xFFFFFF80) == 0x0) ? ((byte)(n10 >> 6)) : ((byte)(n10 >> 6 ^ 0xFC));
                value[n6++] = Base64.lookUpBase64Alphabet[n13];
                value[n6++] = Base64.lookUpBase64Alphabet[n14 | n12 << 4];
                value[n6++] = Base64.lookUpBase64Alphabet[n11 << 2 | n15];
                value[n6++] = Base64.lookUpBase64Alphabet[n10 & 0x3F];
                ++i;
            }
        }
        while (i < n4) {
            int n16 = array[n7++];
            int n17 = array[n7++];
            int n18 = array[n7++];
            int n19 = (byte)(n17 & 0xF);
            int n20 = (byte)(n16 & 0x3);
            int n21 = ((n16 & 0xFFFFFF80) == 0x0) ? ((byte)(n16 >> 2)) : ((byte)(n16 >> 2 ^ 0xC0));
            int n22 = ((n17 & 0xFFFFFF80) == 0x0) ? ((byte)(n17 >> 4)) : ((byte)(n17 >> 4 ^ 0xF0));
            int n23 = ((n18 & 0xFFFFFF80) == 0x0) ? ((byte)(n18 >> 6)) : ((byte)(n18 >> 6 ^ 0xFC));
            value[n6++] = Base64.lookUpBase64Alphabet[n21];
            value[n6++] = Base64.lookUpBase64Alphabet[n22 | n20 << 4];
            value[n6++] = Base64.lookUpBase64Alphabet[n19 << 2 | n23];
            value[n6++] = Base64.lookUpBase64Alphabet[n18 & 0x3F];
            ++i;
        }
        if (n3 == 8L) {
            int n30 = array[n7];
            int n31 = (byte)(n30 & 0x3);
            value[n6++] = Base64.lookUpBase64Alphabet[((n30 & 0xFFFFFF80) == 0x0) ? ((byte)(n30 >> 2)) : ((byte)(n30 >> 2 ^ 0xC0))];
            value[n6++] = Base64.lookUpBase64Alphabet[n31 << 4];
            value[n6++] = '=';
            value[n6++] = '=';
        }
        else if (n3 == 16L) {
            int n24 = array[n7];
            int n25 = array[n7 + 1];
            int n26 = (byte)(n25 & 0xF);
            int n27 = (byte)(n24 & 0x3);
            int n28 = ((n24 & 0xFFFFFF80) == 0x0) ? ((byte)(n24 >> 2)) : ((byte)(n24 >> 2 ^ 0xC0));
            int n29 = ((n25 & 0xFFFFFF80) == 0x0) ? ((byte)(n25 >> 4)) : ((byte)(n25 >> 4 ^ 0xF0));
            value[n6++] = Base64.lookUpBase64Alphabet[n28];
            value[n6++] = Base64.lookUpBase64Alphabet[n29 | n27 << 4];
            value[n6++] = Base64.lookUpBase64Alphabet[n26 << 2];
            value[n6++] = '=';
        }
        return new String(value);
    }
    
    public static final byte[] decode(String s) throws Base64DecodingException {
        if (s == null) {
            return null;
        }
        byte[] array = new byte[s.length()];
        return decodeInternal(array, getBytesInternal(s, array));
    }
    
    protected static final int getBytesInternal(String s, byte[] array) {
        int length = s.length();
        int n = 0;
        for (int i = 0; i < length; ++i) {
            int n2 = (byte)s.charAt(i);
            if (!isWhiteSpace((byte)n2)) {
                array[n++] = n2;
            }
        }
        return n;
    }
    
    protected static final byte[] decodeInternal(byte[] array, int removeWhiteSpace) throws Base64DecodingException {
        if (removeWhiteSpace == -1) {
            removeWhiteSpace = removeWhiteSpace(array);
        }
        if (removeWhiteSpace % 4 != 0) {
            throw new Base64DecodingException("decoding.divisible.four");
        }
        int n = removeWhiteSpace / 4;
        if (n == 0) {
            return new byte[0];
        }
        int n2 = (n - 1) * 4;
        int n3 = (n - 1) * 3;
        int n4 = Base64.base64Alphabet[array[n2++]];
        int n5 = Base64.base64Alphabet[array[n2++]];
        if (n4 == -1 || n5 == -1) {
            throw new Base64DecodingException("decoding.general");
        }
        int n7;
        int n6 = Base64.base64Alphabet[n7 = array[n2++]];
        int n9;
        int n8 = Base64.base64Alphabet[n9 = array[n2++]];
        byte[] array2;
        if (n6 == -1 || n8 == -1) {
            if (isPad((byte)n7) && isPad((byte)n9)) {
                if ((n5 & 0xF) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                array2 = new byte[n3 + 1];
                array2[n3] = (byte)(n4 << 2 | n5 >> 4);
            }
            else if (!isPad((byte)n7) && isPad((byte)n9)) {
                if ((n6 & 0x3) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                array2 = new byte[n3 + 2];
                array2[n3++] = (byte)(n4 << 2 | n5 >> 4);
                array2[n3] = (byte)((n5 & 0xF) << 4 | (n6 >> 2 & 0xF));
            }
            else {
                throw new Base64DecodingException("decoding.general");
            }
        }
        else {
            array2 = new byte[n3 + 3];
            array2[n3++] = (byte)(n4 << 2 | n5 >> 4);
            array2[n3++] = (byte)((n5 & 0xF) << 4 | (n6 >> 2 & 0xF));
            array2[n3++] = (byte)(n6 << 6 | n8);
        }
        int n10 = 0;
        int n11 = 0;
        int i = n - 1;
        while (i > 0) {
            int n12 = Base64.base64Alphabet[array[n11++]];
            int n13 = Base64.base64Alphabet[array[n11++]];
            int n14 = Base64.base64Alphabet[array[n11++]];
            int n15 = Base64.base64Alphabet[array[n11++]];
            if (n12 == -1 || n13 == -1 || n14 == -1 || n15 == -1) {
                throw new Base64DecodingException("decoding.general");
            }
            array2[n10++] = (byte)(n12 << 2 | n13 >> 4);
            array2[n10++] = (byte)((n13 & 0xF) << 4 | (n14 >> 2 & 0xF));
            array2[n10++] = (byte)(n14 << 6 | n15);
            --i;
        }
        return array2;
    }
    
    public static final void decode(String s, OutputStream outputStream) throws Base64DecodingException, IOException {
        byte[] array = new byte[s.length()];
        decode(array, outputStream, getBytesInternal(s, array));
    }
    
    public static final void decode(byte[] array, OutputStream outputStream) throws Base64DecodingException, IOException {
        decode(array, outputStream, -1);
    }
    
    protected static final void decode(byte[] array, OutputStream outputStream, int removeWhiteSpace) throws Base64DecodingException, IOException {
        if (removeWhiteSpace == -1) {
            removeWhiteSpace = removeWhiteSpace(array);
        }
        if (removeWhiteSpace % 4 != 0) {
            throw new Base64DecodingException("decoding.divisible.four");
        }
        int n = removeWhiteSpace / 4;
        if (n == 0) {
            return;
        }
        int n2 = 0;
        int i = n - 1;
        while (i > 0) {
            int n3 = Base64.base64Alphabet[array[n2++]];
            int n4 = Base64.base64Alphabet[array[n2++]];
            int n5 = Base64.base64Alphabet[array[n2++]];
            int n6 = Base64.base64Alphabet[array[n2++]];
            if (n3 == -1 || n4 == -1 || n5 == -1 || n6 == -1) {
                throw new Base64DecodingException("decoding.general");
            }
            outputStream.write((int)(byte)(n3 << 2 | n4 >> 4));
            outputStream.write((int)(byte)((n4 & 0xF) << 4 | (n5 >> 2 & 0xF)));
            outputStream.write((int)(byte)(n5 << 6 | n6));
            --i;
        }
        int n7 = Base64.base64Alphabet[array[n2++]];
        int n8 = Base64.base64Alphabet[array[n2++]];
        if (n7 == -1 || n8 == -1) {
            throw new Base64DecodingException("decoding.general");
        }
        int n10;
        int n9 = Base64.base64Alphabet[n10 = array[n2++]];
        int n12;
        int n11 = Base64.base64Alphabet[n12 = array[n2++]];
        if (n9 == -1 || n11 == -1) {
            if (isPad((byte)n10) && isPad((byte)n12)) {
                if ((n8 & 0xF) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                outputStream.write((int)(byte)(n7 << 2 | n8 >> 4));
            }
            else if (!isPad((byte)n10) && isPad((byte)n12)) {
                if ((n9 & 0x3) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                outputStream.write((int)(byte)(n7 << 2 | n8 >> 4));
                outputStream.write((int)(byte)((n8 & 0xF) << 4 | (n9 >> 2 & 0xF)));
            }
            else {
                throw new Base64DecodingException("decoding.general");
            }
        }
        else {
            outputStream.write((int)(byte)(n7 << 2 | n8 >> 4));
            outputStream.write((int)(byte)((n8 & 0xF) << 4 | (n9 >> 2 & 0xF)));
            outputStream.write((int)(byte)(n9 << 6 | n11));
        }
        return;
    }
    
    public static final void decode(InputStream inputStream, OutputStream outputStream) throws Base64DecodingException, IOException {
        int n = 0;
        byte[] array = new byte[4];
        int read;
        while ((read = inputStream.read()) > 0) {
            int n2 = (byte)read;
            if (isWhiteSpace((byte)n2)) {
                continue;
            }
            if (isPad((byte)n2)) {
                array[n++] = n2;
                if (n == 3) {
                    array[n++] = (byte)inputStream.read();
                    break;
                }
                break;
            }
            else {
                if ((array[n++] = n2) == -1) {
                    throw new Base64DecodingException("decoding.general");
                }
                if (n != 4) {
                    continue;
                }
                n = 0;
                int n3 = Base64.base64Alphabet[array[0]];
                int n4 = Base64.base64Alphabet[array[1]];
                int n5 = Base64.base64Alphabet[array[2]];
                int n6 = Base64.base64Alphabet[array[3]];
                outputStream.write((int)(byte)(n3 << 2 | n4 >> 4));
                outputStream.write((int)(byte)((n4 & 0xF) << 4 | (n5 >> 2 & 0xF)));
                outputStream.write((int)(byte)(n5 << 6 | n6));
            }
        }
        int n7 = array[0];
        int n8 = array[1];
        int n9 = array[2];
        int n10 = array[3];
        int n11 = Base64.base64Alphabet[n7];
        int n12 = Base64.base64Alphabet[n8];
        int n13 = Base64.base64Alphabet[n9];
        int n14 = Base64.base64Alphabet[n10];
        if (n13 == -1 || n14 == -1) {
            if (isPad((byte)n9) && isPad((byte)n10)) {
                if ((n12 & 0xF) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                outputStream.write((int)(byte)(n11 << 2 | n12 >> 4));
            }
            else if (!isPad((byte)n9) && isPad((byte)n10)) {
                int n15 = Base64.base64Alphabet[n9];
                if ((n15 & 0x3) != 0x0) {
                    throw new Base64DecodingException("decoding.general");
                }
                outputStream.write((int)(byte)(n11 << 2 | n12 >> 4));
                outputStream.write((int)(byte)((n12 & 0xF) << 4 | (n15 >> 2 & 0xF)));
            }
            else {
                throw new Base64DecodingException("decoding.general");
            }
        }
        else {
            outputStream.write((int)(byte)(n11 << 2 | n12 >> 4));
            outputStream.write((int)(byte)((n12 & 0xF) << 4 | (n13 >> 2 & 0xF)));
            outputStream.write((int)(byte)(n13 << 6 | n14));
        }
    }
    
    protected static final int removeWhiteSpace(byte[] array) {
        if (array == null) {
            return 0;
        }
        int n = 0;
        for (int n2 : array) {
            if (!isWhiteSpace((byte)n2)) {
                array[n++] = n2;
            }
        }
        return n;
    }
    
    static {
        base64Alphabet = new byte[255];
        lookUpBase64Alphabet = new char[64];
        for (int i = 0; i < 255; ++i) {
            Base64.base64Alphabet[i] = -1;
        }
        for (int j = 90; j >= 65; --j) {
            Base64.base64Alphabet[j] = (byte)(j - 65);
        }
        for (int k = 122; k >= 97; --k) {
            Base64.base64Alphabet[k] = (byte)(k - 97 + 26);
        }
        for (int l = 57; l >= 48; --l) {
            Base64.base64Alphabet[l] = (byte)(l - 48 + 52);
        }
        Base64.base64Alphabet[43] = 62;
        Base64.base64Alphabet[47] = 63;
        for (int n = 0; n <= 25; ++n) {
            Base64.lookUpBase64Alphabet[n] = (char)(65 + n);
        }
        for (int n2 = 26, n3 = 0; n2 <= 51; ++n2, ++n3) {
            Base64.lookUpBase64Alphabet[n2] = (char)(97 + n3);
        }
        for (int n4 = 52, n5 = 0; n4 <= 61; ++n4, ++n5) {
            Base64.lookUpBase64Alphabet[n4] = (char)(48 + n5);
        }
        Base64.lookUpBase64Alphabet[62] = '+';
        Base64.lookUpBase64Alphabet[63] = '/';
    }
}
